<?php
/*
Plugin Name: Indeed My Testimonials (Visual Composer Version)
Plugin URI: https://wpindeed.com/
Description: The most shainny Testimonials Showcase plugin. With predifined themes and colors scheme you can display your testimonials with few clicks and without any line of code.
Version: 4.1
Author: WP Indeed
Author URI: https://www.wpindeed.com
Text Domain: indeed-my-testimonials-vc
Domain Path: /languages

*/
if (get_option('imtst_post_type_name')!==FALSE && get_option('imtst_post_type_name')!='' ){
	define('IMTST_POST_TYPE_VC', get_option('imtst_post_type_name'));
	if (IMTST_POST_TYPE_VC=='tetimonials'){
		define('IMTST_TAXONOMY_VC', 'testimonial_groups');
	} else {
		define('IMTST_TAXONOMY_VC', IMTST_POST_TYPE_VC . '_groups');
	}
} else {
	global $wpdb;
	$temp_check = $wpdb->get_var("SELECT COUNT(*) as c FROM {$wpdb->postmeta} WHERE meta_key='imtst_clienturl';");
	if ($temp_check){
		define('IMTST_POST_TYPE_VC', 'testimonials');
		define('IMTST_TAXONOMY_VC', 'team_cats');
	} else {
		define('IMTST_POST_TYPE_VC', 'imtst_testimonials');
		define('IMTST_TAXONOMY_VC', 'imtst_testimonial_groups');
	}
	update_option('imtst_post_type_name', IMTST_POST_TYPE_VC);
}

define('IMTST_DIR_URL_VC', plugin_dir_url(__FILE__));
define('IMTST_DIR_PATH_VC', plugin_dir_path(__FILE__));

add_action('init', 'imtst_load_language_vc');
function imtst_load_language_vc(){
	load_plugin_textdomain( 'indeed-my-testimonials-vc', false, dirname(plugin_basename(__FILE__)).'/languages/' );
}

///FUNCTIONS
include_once IMTST_DIR_PATH_VC . 'includes/functions.php';
/////VISUAL COMPOSER
function imtst_check_vc(){
    if(function_exists('vc_map')){
      //gettings cats
      $args = array(
                    'taxonomy' => IMTST_TAXONOMY_VC,
                    'type' => IMTST_POST_TYPE_VC,
					'hide_empty' => 0,
					'orderby' => 'slug');
      $cats = get_categories($args);
      if(isset($cats) && count($cats)>0){
          foreach($cats as $cat){
                $cat_arr[$cat->slug] = $cat->name;
                $cat_arr_keys[] = $cat->slug;
          }
          $cats_str = implode(',', $cat_arr_keys);
      }else{
            $cat_arr = array();
            $cats_str = '';
      }
        include_once IMTST_DIR_PATH_VC . 'includes/imt_vc_functions.php';
        $dir_url = IMTST_DIR_URL_VC;
        vc_map( array(
        			   "name" => "My Testimonials",
        			   "base" => "indeed-my-testimonials-vc",
        			   "icon" => "icon-wpb-ttp",
                       "description" => "Show My Testimonials",
    			       "class" => "indeed-my-testimonials",
    			       "category" => esc_html__('Content', "js_composer"),
        			   "params" => array(

        									array(
        										"type" => "imtst_select_cats",
        										"heading" => esc_html__("Group", 'indeed-my-testimonials-vc'),
        										"param_name" => "group",
                                                "admin_label" => TRUE,
        										"value" => "all",
        										"description" => "Select one or many Groups with Testimonials"
        									),
                                            array(
                                                "type" => "imtst_number",
        										"heading" => esc_html__("Number of items", 'indeed-my-testimonials-vc'),
        										"param_name" => "limit",
                                                "admin_label" => TRUE,
        										"value" => 10,
        										"param_min_value" => 1,
        										"description" => ""
                                            ),
											array(
        										  "type" => 'imtst_sepparate_line',
												  "param_name" => "line1",
												  'value' => '',
											),
        			   						array(
        			   								"type" => "imtst_number",
        			   								"heading" => esc_html__("Maximum Number Of Characters", 'indeed-my-testimonials-vc'),
        			   								"value" => 250,
        			   								"param_min_value" => 0,
        			   								"description" => "If the Quote is bigger than this value it will be cutted.",
        			   							    "param_name" => "max_num_desc",

        			   						),
        			   						array(
        			   								"type" => "imtst_checkbox_field",
        			   								"label" => esc_html__(" Read More", 'indeed-my-testimonials-vc'),
        			   								"id_checkbox" => "",
        			   								"value" => 0,
        			   								"id_hidden" => "read_more",
        			   								"param_name" => "read_more",
        			   								"onClick" => "",
													"description" => "Add the Expandable option to see the entire Quote.",
        			   								"extra_text" => "<div class='warning_grey_span'>" . esc_html__('Is not available with filter display.', 'indeed-my-testimonials-vc') . "</div>",
        			   						),
											array(
        										  "type" => 'imtst_sepparate_line',
												  "param_name" => "line2",
												  'value' => '',
											),
        									array(
        										"type" => "imtst_custom_dd",
        										"heading" => esc_html__("Order By", 'indeed-my-testimonials-vc'),
                                                "select_id" => "order_by_sel",
                                                "onclick" => "",
        										"param_name" => "order_by",
        										"values" => array("date" => esc_html__("Date", 'indeed-my-testimonials-vc'), "name" => esc_html__("Name", 'indeed-my-testimonials-vc'), 'last_name' => esc_html__('Last Name', 'indeed-my-testimonials-vc'), "rand"=> esc_html__("Random", 'indeed-my-testimonials-vc') ),
        			   							"value" => "name"
        									),
        									array(
        										"type" => "imtst_custom_dd",
        										"heading" => esc_html__("Order Type", 'indeed-my-testimonials-vc'),
                                                "select_id" => "order_type_sel",
        										"param_name" => "order",
                                                "onclick" => "",
        										"values" => array("ASC" => esc_html__("ASC", 'indeed-my-testimonials-vc'), "DESC" => esc_html__("DESC", 'indeed-my-testimonials-vc') ),
												"value" => "ASC"
        									),
											array(
        										  "type" => 'imtst_sepparate_line',
												  "param_name" => "line3",
											      'value' => '',
											),
											array(
        										  "type" => 'imtst_title_block_imtst_bkcolor6',
        										  "heading" => esc_html__("Entry Information", 'indeed-my-testimonials-vc'),
												  "wrap_div" => TRUE,
                                                  "param_name" => "entry_information",
												  "wrap_class" => "imtst_vc_title"
											),
        									array(
        										  "type" => 'imtst_checkbox_block',
        										  "heading" => esc_html__("Custom Field To Show:", 'indeed-my-testimonials-vc'),
        										  "hidden_name" => "show",
                                                  "hidden_id" => "hidden_i_cf",
        										  "param_name" => "show",
        										  "checkboxes" => array("name" => esc_html__(" Name", 'indeed-my-testimonials-vc'),
                                                                        "image" => esc_html__(" Image", 'indeed-my-testimonials-vc'),
                                                                        "quote" => esc_html__(" Quote", 'indeed-my-testimonials-vc'),
                                                                        "job" => esc_html__(" Client Job", 'indeed-my-testimonials-vc'),
                                                                        "client_url" => esc_html__(" Client URL", 'indeed-my-testimonials-vc'),
                                                                        "company" => esc_html__(" Company", 'indeed-my-testimonials-vc'),
                                                                        "company_url" => esc_html__(" Company URL", 'indeed-my-testimonials-vc'),
                                                                        "stars" => esc_html__(" Stars", 'indeed-my-testimonials-vc'),
																		"social" => esc_html__(" Social Links", 'indeed-my-testimonials-vc'),
                                                                        "date" => esc_html__(" Date", 'indeed-my-testimonials-vc'),
                                                                        ),
        										  "value" => "name,image,quote,job,stars"
        									),
											array(
        										  "type" => 'imtst_title_block_imtst_bkcolor1',
        										  "heading" => esc_html__("Template", 'indeed-my-testimonials-vc'),
												  "wrap_div" => TRUE,
                                                  "param_name" => "template",
												  "wrap_class" => "imtst_vc_title"
											),
                                            array(
                                                "type" => "imtst_select_themes",
                                                "heading" => esc_html__("Select a Theme", 'indeed-my-testimonials-vc'),
                                                "param_name" => "theme",
                                                "value" => "",
                                            ),
                                            array(
                                                "type" => "imtst_color_scheme",
                                                "heading" => esc_html__("Select Color Scheme", 'indeed-my-testimonials-vc'),
                                                "param_name" => "color_scheme",
                                                "value" => "0a9fd8"
                                            ),
											array(
        										  "type" => 'imtst_sepparate_line',
												  "param_name" => "line4",
												  'value' => '',
											),
                                            array(
                                                "type" => "imtst_checkbox_field",
                                                "label" => esc_html__(" Disable Hover Effect", 'indeed-my-testimonials-vc'),
                                                "id_checkbox" => "",
                                                "value" => 0,
                                                "onClick" => "",
                                                "id_hidden" => "disable_hover_effect",
                                                "param_name" => "disable_hover",
                                            ),
				        			   		array(
				        			   				"type" => "imtst_checkbox_field",
				        			   				"label" => esc_html__(" Align The Items Centered", 'indeed-my-testimonials-vc'),
				        			   				"id_checkbox" => "align_center",
				        			   				"value" => 0,
				        			   				"id_hidden" => "h_align_center",
				        			   				"param_name" => "align_center",
				        			   				"onClick" => ""
				        			   		),
											array(
        										  "type" => 'imtst_sepparate_line',
												  "param_name" => "line5",
												  'value' => '',
											),
                                            array(
        										"type" => "dropdown",
        										"heading" => esc_html__("Number of Columns:", 'indeed-my-testimonials-vc'),
        										"param_name" => "columns",
        										"value" => array(1,2,3,4,5,6),
                                                "std" => 2
                                            ),
                                            ///////////////SLIDER
											array(
        										  "type" => 'imtst_title_block_imtst_bkcolor2',
        										  "heading" => esc_html__("Slider ShowCase", 'indeed-my-testimonials-vc'),
												  "wrap_div" => TRUE,
                                                  "param_name" => "slider_title",
												  "wrap_class" => "imtst_vc_title"
											),
                                            array(
                                                "type" => "imtst_checkbox_field_actv",
                                                "label" => esc_html__(" Show as Slider", 'indeed-my-testimonials-vc'),
												"heading" => esc_html__("Activate the Slider", 'indeed-my-testimonials-vc'),
                                                "id_checkbox" => "slider_main_checkbox",
                                                "value" => 0,
                                                "id_hidden" => "show_as_slider",
                                                "param_name" => "slider_set",
                                                "onClick" => "check_mf_selector(this, \".slider_options\", \"opacity\", 1, \"0.5\", \".filter_options\", \"#filter_main_checkbox\",\"#show_as_filter\");",
                                                "slider_or_filter" => "slider",
												"extra_text" => "<div class='warning_grey_span'>" . esc_html__('If Slider Showcase is used, Filter Showcase is disabled.', 'indeed-my-testimonials-vc') . "</div>"
                                            ),
        									array(
        										"type" => "imtst_number",
                                                "heading" => esc_html__("Items per Slide:", 'indeed-my-testimonials-vc'),
        										"param_name" => "items_per_slide",
        										"value" => 1,
                                                "std" => 2,
        										"param_min_value" => 1,
        										"description" => "",
                                                "wrap_div" => TRUE  ,
                                                "wrap_class" => "slider_options",
                                                "slider_or_filter" => "slider"
        									),
        									array(
        										"type" => "imtst_number",
        										"heading" => esc_html__("Slide TimeOut", 'indeed-my-testimonials-vc'),
        										"param_name" => "slide_speed",
        										"value" => 5000,
        										"param_min_value" => 1,
        										"description" => "",
                                                "wrap_div" => TRUE,
                                                "wrap_class" => "slider_options",
                                                "slider_or_filter" => "slider"
        									),
        									array(
        										"type" => "imtst_number",
        										"heading" => esc_html__("Pagination Speed", 'indeed-my-testimonials-vc'),
        										"param_name" => "slide_pagination_speed",
        										"value" => 500,
        										"param_min_value" => 1,
        										"description" => "",
                                                "wrap_div" => TRUE,
                                                "wrap_class" => "slider_options",
                                                "slider_or_filter" => "slider"
        									),
											array(
        										  "type" => 'imtst_sepparate_line',
												  "param_name" => "line6",
												  'value' => '',
											),
        									array(
        										  "type" => 'imtst_checkbox_block',
        										  "heading" => "Additional Options",
        										  "hidden_name" => "slide_opt",
                                                  "hidden_id" => "hidden_slide_opt",
        										  "param_name" => "slide_opt",
        										  "checkboxes" => array("bullets"=>esc_html__(" Bullets", 'indeed-my-testimonials-vc'), "nav_button"=>esc_html__(" Nav Button", 'indeed-my-testimonials-vc'), "autoplay"=>esc_html__(" Autoplay", 'indeed-my-testimonials-vc'), "stop_hover"=>esc_html__(" Stop Hover", 'indeed-my-testimonials-vc'), "responsive"=> esc_html__(" Responsive", 'indeed-my-testimonials-vc'), "autoheight"=> esc_html__(" Auto Height", 'indeed-my-testimonials-vc'), "lazy_load"=>esc_html__(" Lazy Load", 'indeed-my-testimonials-vc'), "loop"=>esc_html__(" Play in Loop", 'indeed-my-testimonials-vc')),
        										  "value" => "bullets,nav_button,autoplay,stop_hover,responsive,autoheight,loop",
                                                  "wrap_div" => TRUE,
                                                  "wrap_class" => "slider_options",
                                                  "slider_or_filter" => "slider"
        									),
											array(
                                                  "type" => "imtst_custom_dropdown",
                                                  "label" => esc_html__("Pagination Theme", 'indeed-my-testimonials-vc'),
                                                  "param_name" => "pagination_theme",
                                                  "values" => array("pag-theme1"=>esc_html__("Pagination Theme 1", 'indeed-my-testimonials-vc'), "pag-theme2"=>esc_html__("Pagination Theme 2", 'indeed-my-testimonials-vc'), "pag-theme3"=>esc_html__("Pagination Theme 3", 'indeed-my-testimonials-vc'),),
                                                  "value" => "",
                                                  "wrap_div" => TRUE,
                                                  "wrap_class" => "slider_options",
                                                  "slider_or_filter" => "slider"
                                            ),
											array(
        										  "type" => 'imtst_sepparate_line',
												  "param_name" => "line7",
												  'value' => '',
											),
                                            array(
                                                  "type" => "imtst_custom_dropdown",
                                                  "label" => esc_html__("Animation Slide In", 'indeed-my-testimonials-vc'),
                                                  "param_name" => "animation_in",
                                                  "values" => array("none"=>esc_html__("None", 'indeed-my-testimonials-vc'), "fadeIn"=>esc_html__("fadeIn", 'indeed-my-testimonials-vc'), "fadeInDown"=>esc_html__("fadeInDown", 'indeed-my-testimonials-vc'), "fadeInUp"=>esc_html__("fadeInUp", 'indeed-my-testimonials-vc'), "slideInDown"=>esc_html__("slideInDown", 'indeed-my-testimonials-vc'), "slideInUp"=>esc_html__("slideInUp", 'indeed-my-testimonials-vc'), "flip"=>esc_html__("flip", 'indeed-my-testimonials-vc'),
												  					"flipInX"=>esc_html__("flipInX", 'indeed-my-testimonials-vc'),"flipInY"=>esc_html__("flipInY", 'indeed-my-testimonials-vc'),"bounceIn"=>esc_html__("bounceIn", 'indeed-my-testimonials-vc'),"bounceInDown"=>esc_html__("bounceInDown", 'indeed-my-testimonials-vc'),"bounceInUp"=>esc_html__("bounceInUp", 'indeed-my-testimonials-vc'),"rotateIn"=>esc_html__("rotateIn", 'indeed-my-testimonials-vc'),"rotateInDownLeft"=>esc_html__("rotateInDownLeft", 'indeed-my-testimonials-vc'),
																	"rotateInDownRight"=>esc_html__("rotateInDownRight", 'indeed-my-testimonials-vc'),"rollIn"=>esc_html__("rollIn", 'indeed-my-testimonials-vc'),"zoomIn"=>esc_html__("zoomIn", 'indeed-my-testimonials-vc'),"zoomInDown"=>esc_html__("zoomInDown", 'indeed-my-testimonials-vc'),"zoomInUp"=>esc_html__("zoomInUp", 'indeed-my-testimonials-vc')),
                                                  "value" => "",
                                                  "wrap_div" => TRUE,
                                                  "wrap_class" => "slider_options",
                                                  "slider_or_filter" => "slider"
                                            ),
											 array(
                                                  "type" => "imtst_custom_dropdown",
                                                  "label" => esc_html__("Animation Slide Out", 'indeed-my-testimonials-vc'),
                                                  "param_name" => "animation_out",
                                                  "values" => array("none"=>esc_html__("None", 'indeed-my-testimonials-vc'), "fadeOut"=>esc_html__("fadeOut", 'indeed-my-testimonials-vc'), "fadeOutDown"=>esc_html__("fadeOutDown", 'indeed-my-testimonials-vc'), "fadeOutUp"=>esc_html__("fadeOutUp", 'indeed-my-testimonials-vc'), "slideOutDown"=>esc_html__("slideOutDown", 'indeed-my-testimonials-vc'), "slideOutUp"=>esc_html__("slideOutUp", 'indeed-my-testimonials-vc'), "flip"=>esc_html__("flip", 'indeed-my-testimonials-vc'),
												  					"flipOutX"=>esc_html__("flipOutX", 'indeed-my-testimonials-vc'),"flipOutY"=>esc_html__("flipOutY", 'indeed-my-testimonials-vc'),"bounceOut"=>esc_html__("bounceOut", 'indeed-my-testimonials-vc'),"bounceOutDown"=>esc_html__("bounceOutDown", 'indeed-my-testimonials-vc'),"bounceOutUp"=>esc_html__("bounceOutUp", 'indeed-my-testimonials-vc'),"rotateOut"=>esc_html__("rotateOut", 'indeed-my-testimonials-vc'),"rotateOutUpLeft"=>esc_html__("rotateOutUpLeft", 'indeed-my-testimonials-vc'),
																	"rotateOutUpRight"=>esc_html__("rotateOutUpRight", 'indeed-my-testimonials-vc'),"rollOut"=>esc_html__("rollOut", 'indeed-my-testimonials-vc'),"zoomOut"=>esc_html__("zoomOut", 'indeed-my-testimonials-vc'),"zoomOutDown"=>esc_html__("zoomOutDown", 'indeed-my-testimonials-vc'),"zoomOutUp"=>esc_html__("zoomOutUp", 'indeed-my-testimonials-vc')),
                                                  "value" => "",
                                                  "wrap_div" => TRUE,
                                                  "wrap_class" => "slider_options",
                                                  "slider_or_filter" => "slider"
                                            ),
                                            ////////////FILTER
											array(
        										  "type" => 'imtst_title_block_imtst_bkcolor3',
        										  "heading" => esc_html__("Filter ShowCase", 'indeed-my-testimonials-vc'),
												  "wrap_div" => TRUE,
                                                  "param_name" => "filter_title",
												  "wrap_class" => "imtst_vc_title"
											),
                                            array(
                                                "type" => "imtst_checkbox_field_actv",
                                                "label" => esc_html__(" Show Filter", 'indeed-my-testimonials-vc'),
												"heading" => esc_html__("Activate the Filter", 'indeed-my-testimonials-vc'),
                                                "id_checkbox" => "filter_main_checkbox",
                                                "value" => 0,
                                                "id_hidden" => "show_as_filter",
                                                "param_name" => "filter_set",
                                                "onClick" => "check_mf_selector(this, \".filter_options\", \"opacity\", 1, \"0.5\", \".slider_options\", \"#slider_main_checkbox\", \"#show_as_slider\");",
                                                "slider_or_filter" => "filter",
												"extra_text" => "<div class='warning_grey_span'>" . esc_html__('If Filter Showcase is used, Slider Showcase is disabled.', 'indeed-my-testimonials-vc') . "</div>"
                                            ),
											array(
        										  "type" => 'imtst_sepparate_line',
												  "param_name" => "line8",
												  'value' => '',
											),
        									array(
        										  "type" => 'imtst_checkbox_block',
        										  "label" => esc_html__("Groups", 'indeed-my-testimonials-vc'),
												  "heading" => esc_html__("Groups List", 'indeed-my-testimonials-vc'),
        										  "hidden_name" => "filter_testimonials",
                                                  "hidden_id" => "hidden-filtertestimonials",
        										  "param_name" => "filter_testimonials",
        										  "checkboxes" => $cat_arr,
        										  "value" => '',
                                                  "wrap_div" => TRUE,
                                                  "wrap_class" => "filter_options",
                                                  "slider_or_filter" => "filter",
        									),
											array(
        										  "type" => 'imtst_sepparate_line',
												  "param_name" => "line9",
												  'value' => '',
											),
                                            array(
                                                  "type" => "imtst_custom_dropdown",
                                                  "heading" => esc_html__("Theme", 'indeed-my-testimonials-vc'),
                                                  "param_name" => "filter_select_t",
                                                  "values" => array('small_text'=>esc_html__('Small Text', 'indeed-my-testimonials-vc'), 'big_text'=>esc_html__('Big Text', 'indeed-my-testimonials-vc'), 'small_button'=>esc_html__('Small Button', 'indeed-my-testimonials-vc'),'big_button'=>esc_html__('Big Buttons', 'indeed-my-testimonials-vc'),'dropdown'=>esc_html__('Drop Down', 'indeed-my-testimonials-vc') ),
                                                  "value" => "",
                                                  "wrap_div" => TRUE,
                                                  "wrap_class" => "filter_options" ,
                                                  "slider_or_filter" => "filter",
                                            ),
                                            array(
                                                  "type" => "imtst_custom_dropdown",
                                                  "heading" => esc_html__("Align", 'indeed-my-testimonials-vc'),
                                                  "param_name" => "filter_align",
                                                  "values" => array('left'=>esc_html__('Left', 'indeed-my-testimonials-vc'),'center'=>esc_html__('Center', 'indeed-my-testimonials-vc'),'right'=>esc_html__('Right', 'indeed-my-testimonials-vc') ),
                                                  "value" => "",
                                                  "wrap_div" => TRUE,
                                                  "wrap_class" => "filter_options",
                                                  "slider_or_filter" => "filter",
                                            ),
				        			   		array(
				        			   				"type" => "imtst_custom_dropdown",
				        			   				"heading" => esc_html__("Layout Mode", 'indeed-my-testimonials-vc'),
				        			   				"param_name" => "layout_mode",
				        			   				"values" => array('masonry'=>esc_html__('masonry', 'indeed-my-testimonials-vc'),'fitRows'=>esc_html__('fitRows', 'indeed-my-testimonials-vc') ),
				        			   				"value" => "",
				        			   				"wrap_div" => TRUE,
				        			   				"wrap_class" => "filter_options",
				        			   				"slider_or_filter" => "filter",
				        			   		),
                                            //////////end of filter
											array(
        										  "type" => 'imtst_title_block_imtst_bkcolor5',
        										  "heading" => esc_html__("Inside Page Options", 'indeed-my-testimonials-vc'),
												  "wrap_div" => TRUE,
                                                  "param_name" => "insidepage_title",
												  "wrap_class" => "imtst_vc_title"
											),
                                            array(
                                                  "type" => "imtst_checkbox_field",
                                                  "label" => esc_html__(" Activate Inside Page", 'indeed-my-testimonials-vc'),
                                                  "id_checkbox" => "page_inside_c",
                                                  "value" => 0,
                                                  "id_hidden" => "page_inside",
                                                  "param_name" => "page_inside",
                                                  "onClick" => 'imtst_uncheck_c_hz(this, "#tmst_custom_href_c", "#tmst_custom_href");',
                                            ),
                                            array(
                                                  "type" => "imtst_inside_template",
                                                  "param_name" => "inside_template",
                                                  "value" => "",
                                                  "heading" => esc_html__("Template", 'indeed-my-testimonials-vc'),
                                            ),
											array(
        										  "type" => 'imtst_sepparate_line',
												  "param_name" => "line10",
												  'value' => '',
											),
											array(
				        			   				"type" => "imtst_checkbox_field",
				        			   				"label" => esc_html__(" Activate Custom Link", 'indeed-my-testimonials-vc'),
				        			   				"id_checkbox" => "tmst_custom_href_c",
				        			   				"value" => 0,
				        			   				"id_hidden" => "tmst_custom_href",
				        			   				"param_name" => "tmst_custom_href",
				        			   				"onClick" => 'imtst_uncheck_c_hz(this, "#page_inside_c", "#page_inside");',
				        			   		),
											array(
        										  "type" => 'imtst_sepparate_line',
                                                  "param_name" => "line13"
											)
        								)
        			)
        );


        $cat_arr = imtst_get_cats_for_vc_admin();


        vc_map( array(
        			   "name" => esc_html__("My Testimonials Form Builder", 'indeed-my-testimonials-vc' ),
        			   "base" => "indeed-my-testimonials-form-vc",
        			   "icon" => "icon-wpb-ttp",
                       "description" => esc_html__("Form Builder", 'indeed-my-testimonials-vc'),
    			       "class" => "indeed-my-testimonials-form",
    			       "category" => esc_html__('Content', "js_composer"),
        			   "params" => array(
                                            array(
        										  "type" => 'imtst_checkbox_block',
        										  "heading" => esc_html__("Fields To Show:", 'indeed-my-testimonials-vc'),
        										  "hidden_name" => "show",
                                                  "hidden_id" => "hidden_i_cf",
        										  "param_name" => "show",
        										  "checkboxes" => array("client_name" => esc_html__(" Client Name", 'indeed-my-testimonials-vc'),
                                                                        "client_image" => esc_html__(" Client Image", 'indeed-my-testimonials-vc'),
                                                                        "client_job" => esc_html__(" Client Job", 'indeed-my-testimonials-vc'),
                                                                        "client_url" => esc_html__(" Client URL", 'indeed-my-testimonials-vc'),
                                                                        "company" => esc_html__(" Company", 'indeed-my-testimonials-vc'),
                                                                        "company_url" => esc_html__(" Company URL", 'indeed-my-testimonials-vc'),
                                                                        "quote" => esc_html__(" Quote", 'indeed-my-testimonials-vc'),
                                                                        "rating" => esc_html__(" Rating", 'indeed-my-testimonials-vc'),
        										  						"capcha" => esc_html__(" Capcha", 'indeed-my-testimonials-vc'),
                                                                        ),
        										  "value" => "client_name,client_job,company,quote",
        									),
        			   		array(
        			   				"type" => "imtst_custom_dropdown",
        			   				"heading" => esc_html__("Destination Group", 'indeed-my-testimonials-vc'),
        			   				"param_name" => "d_group",
        			   				"values" => $cat_arr,
        			   				"value" => "",
        			   		),
											array(
        										  "type" => 'imtst_title_block',
        										  "heading" => esc_html__("Required Fields", 'indeed-my-testimonials-vc'),
												  "wrap_div" => TRUE,
                                                  "param_name" => "required_title",
												  "wrap_class" => "imtst_vc_title"
											),
                                            array(
        										  "type" => 'imtst_checkbox_block',
        										  "heading" => esc_html__("Required Fields:", 'indeed-my-testimonials-vc'),
        										  "hidden_name" => "req",
                                                  "hidden_id" => "hidden_i_rf",
        										  "param_name" => "req",
        										  "checkboxes" => array("client_name" => esc_html__(" Client Name", 'indeed-my-testimonials-vc'),
                                                                        "client_image" => esc_html__(" Client Image", 'indeed-my-testimonials-vc'),
                                                                        "client_job" => esc_html__(" Client Job", 'indeed-my-testimonials-vc'),
                                                                        "client_url" => esc_html__(" Client URL", 'indeed-my-testimonials-vc'),
                                                                        "company" => esc_html__(" Company", 'indeed-my-testimonials-vc'),
                                                                        "company_url" => esc_html__(" Company URL", 'indeed-my-testimonials-vc'),
                                                                        "quote" => esc_html__(" Quote", 'indeed-my-testimonials-vc'),
                                                                        "rating" => esc_html__(" Rating", 'indeed-my-testimonials-vc'),
                                                                        ),
        										  "value" => "client_name,quote",
        									),
											array(
        										  "type" => 'imtst_title_block imtst_bkcolor1',
        										  "heading" => esc_html__("Custom Labels", 'indeed-my-testimonials-vc'),
												  "wrap_div" => TRUE,
                                                  "param_name" => "label_title",
												  "wrap_class" => "imtst_vc_title"
											),
                                            array(
                                                    "type" => "imtst_label",
                                                    "param_name" => "label",
                                                    "value" => esc_html__("Field Labels:", 'indeed-my-testimonials-vc'),
                                                    "class" => "imtst_label",
                                            ),
                                            array(
                                                    "type" => "textfield",
                                                    "heading" => esc_html__("Client Name:", 'indeed-my-testimonials-vc'),
                                                    "param_name" => "client_name",
                                                    "value" => esc_html__("Name", 'indeed-my-testimonials-vc'),
                                            ),
                                            array(
                                                    "type" => "textfield",
                                                    "heading" => esc_html__("Client Image:", 'indeed-my-testimonials-vc'),
                                                    "param_name" => "client_image",
                                                    "value" => esc_html__("Image", 'indeed-my-testimonials-vc'),
                                            ),
                                            array(
                                                    "type" => "textfield",
                                                    "heading" => esc_html__("Client Job:", 'indeed-my-testimonials-vc'),
                                                    "param_name" => "client_job",
                                                    "value" => esc_html__("Position", 'indeed-my-testimonials-vc'),
                                            ),
                                            array(
                                                    "type" => "textfield",
                                                    "heading" => esc_html__("Client URL:", 'indeed-my-testimonials-vc'),
                                                    "param_name" => "client_url",
                                                    "value" => esc_html__("URL", 'indeed-my-testimonials-vc'),
                                            ),
                                            array(
                                                    "type" => "textfield",
                                                    "heading" => esc_html__("Company:", 'indeed-my-testimonials-vc'),
                                                    "param_name" => "company",
                                                    "value" => esc_html__("Company", 'indeed-my-testimonials-vc'),
                                            ),
                                            array(
                                                    "type" => "textfield",
                                                    "heading" => esc_html__("Company URL:", 'indeed-my-testimonials-vc'),
                                                    "param_name" => "company_url",
                                                    "value" => esc_html__("Company URL", 'indeed-my-testimonials-vc'),
                                            ),
                                            array(
                                                    "type" => "textfield",
                                                    "heading" => esc_html__("Quote:", 'indeed-my-testimonials-vc'),
                                                    "param_name" => "quote",
                                                    "value" => esc_html__("Testimonial", 'indeed-my-testimonials-vc'),
                                            ),
				        			   		array(
				        			   				"type" => "textfield",
				        			   				"heading" => esc_html__("Capcha Label:", 'indeed-my-testimonials-vc'),
				        			   				"param_name" => "capcha_label",
				        			   				"value" => esc_html__("CapCha", 'indeed-my-testimonials-vc'),
				        			   		),
                                            array(
                                                    "type" => "textfield",
                                                    "heading" => esc_html__("Rating:", 'indeed-my-testimonials-vc'),
                                                    "param_name" => "rating",
                                                    "value" => esc_html__("Rating", 'indeed-my-testimonials-vc'),
                                            ),
											array(
        										  "type" => 'imtst_title_block imtst_bkcolor5',
        										  "heading" => esc_html__("Custom Messages", 'indeed-my-testimonials-vc'),
												  "wrap_div" => TRUE,
                                                  "param_name" => "messages_title",
												  "wrap_class" => "imtst_vc_title"
											),
                                            array(
                                                  "type" => "imtst_textarea",
                                                  "param_name" => "e_msg",
                                                  "value" => esc_html__("Thank you for your submitted testimonial!", 'indeed-my-testimonials-vc'),
                                                  "heading" => esc_html__("Success message", 'indeed-my-testimonials-vc'),
                                            ),
                                            array(
                                                  "type" => "imtst_textarea",
                                                  "param_name" => "err_msg",
                                                  "value" => esc_html__("An Error has Occurred. Please Try Again and complete all the required fields!", 'indeed-my-testimonials-vc'),
                                                  "heading" => esc_html__("Error message", 'indeed-my-testimonials-vc'),
                                            ),
                       )
                      )
        );
        add_action("admin_enqueue_scripts", 'imtst_admin_header');
        function imtst_admin_header(){
            wp_enqueue_style( 'imtst_style_vc', IMTST_DIR_URL_VC . 'files/css/style.css', array(), null );
            wp_enqueue_script( 'imtst_js_functions_vc', IMTST_DIR_URL_VC . 'files/js/functions.js', array(), null );
        }
    }
}
add_action( 'init', 'imtst_check_vc' );
//////// imtst on EACH FUNCTION NAME

add_action( 'init', 'imtst_post_testimonials_vc' );
function imtst_post_testimonials_vc() {
  $labels = array(
    'name'               => esc_html__('Testimonials', 'indeed-my-testimonials-vc'),
    'singular_name'      => esc_html__('Testimonial', 'indeed-my-testimonials-vc'),
    'add_new'            => esc_html__('Add New Testimonial', 'indeed-my-testimonials-vc'),
    'add_new_item'       => esc_html__('Add New Testimonial', 'indeed-my-testimonials-vc'),
    'edit_item'          => esc_html__('Edit Testimonial', 'indeed-my-testimonials-vc'),
    'new_item'           => esc_html__('New Testimonial', 'indeed-my-testimonials-vc'),
    'all_items'          => esc_html__('All Testimonials', 'indeed-my-testimonials-vc'),
    'view_item'          => esc_html__('View Testimonial', 'indeed-my-testimonials-vc'),
    'search_items'       => esc_html__('Search Testimonial', 'indeed-my-testimonials-vc'),
    'not_found'          => esc_html__('No Testimonial available', 'indeed-my-testimonials-vc'),
    'not_found_in_trash' => esc_html__('No Testimonials found in Trash', 'indeed-my-testimonials-vc'),
    'parent_item_colon'  => '',
    'menu_name'          => esc_html__('My Testimonials', 'indeed-my-testimonials-vc'),
  );
  $args = array(
    'labels'             => $labels,
    'public'             => true,
    'publicly_queryable' => true,
    'show_ui'            => true,
    'show_in_menu'       => true,
    'query_var'          => true,
    'capability_type'    => 'post',
    'has_archive'        => true,
    'hierarchical'       => false,
    'menu_position'      => 8,
    'menu_icon'          => IMTST_DIR_URL_VC . 'files/images/ed-gray.png',
    'supports'           => array( 'title', 'editor', 'thumbnail' )
  );
    register_post_type( IMTST_POST_TYPE_VC, $args );
}

////////////TAXONOMY
add_action( 'init', 'imtst_taxonomy_testimonials_vc', 0 );
function imtst_taxonomy_testimonials_vc() {
		$labels = array(
			'name'              => _x( 'Groups', 'taxonomy general name' ),
			'singular_name'     => _x( 'Group', 'taxonomy singular name' ),
			'search_items'      => esc_html__( 'Search Groups', 'indeed-my-testimonials-vc' ),
			'all_items'         => esc_html__( 'All Groups', 'indeed-my-testimonials-vc' ),
			'parent_item'       => esc_html__( 'Parent Group', 'indeed-my-testimonials-vc' ),
			'parent_item_colon' => esc_html__( 'Parent Group:', 'indeed-my-testimonials-vc' ),
			'edit_item'         => esc_html__( 'Edit Group', 'indeed-my-testimonials-vc' ),
			'update_item'       => esc_html__( 'Update Group', 'indeed-my-testimonials-vc' ),
			'add_new_item'      => esc_html__( 'Add New Group', 'indeed-my-testimonials-vc' ),
			'new_item_name'     => esc_html__( 'New Group Name', 'indeed-my-testimonials-vc' ),
			'menu_name'         => esc_html__( 'Groups', 'indeed-my-testimonials-vc' ),
		);
		$args = array(
			'hierarchical'      => true,
			'labels'            => $labels,
			'show_ui'           => true,
			'show_admin_column' => true,
			'query_var'         => true,
			'rewrite'           => array( 'slug' => IMTST_TAXONOMY_VC ),
		);
	register_taxonomy( IMTST_TAXONOMY_VC, IMTST_POST_TYPE_VC, $args );
}
////RENAME FEATURED IMAGE TO CLIENT IMAGE
add_action('do_meta_boxes', 'imtst_change_image_box_vc');
function imtst_change_image_box_vc(){
    remove_meta_box( 'postimagediv', IMTST_POST_TYPE_VC, 'side' );
    add_meta_box('postimagediv', esc_html__('Client Image', 'indeed-my-testimonials-vc'), 'post_thumbnail_meta_box', IMTST_POST_TYPE_VC, 'normal', 'low');
}
add_action('admin_head-post-new.php', 'imtst_change_thumbnail_html_vc');
add_action('admin_head-post.php', 'imtst_change_thumbnail_html_vc');
function imtst_change_thumbnail_html_vc( $content ) {
    if ( $GLOBALS['post_type']==IMTST_POST_TYPE_VC )
      add_filter('admin_post_thumbnail_html', 'imtst_rename_thumb_vc');
}
function imtst_rename_thumb_vc($content){
     return str_replace(esc_html__('featured image'), esc_html__('Client Image', 'indeed-my-testimonials-vc'),$content);
}
/////////CUSTOM FIELD
    //////////INFO
    add_action( 'add_meta_boxes', 'imtst_cf_ti_vc' );
    function imtst_cf_ti_vc(){
        add_meta_box('client_personal_info',
                     esc_html__('Client Information', 'indeed-my-testimonials-vc'),
                     'imtst_metabox_ti_vc', //function available in function.php
                     IMTST_POST_TYPE_VC,
                     'normal',
                     'low');
    }
    add_action('save_post', 'imtst_save_ti_vc');
    //////////RATINGS
    add_action( 'add_meta_boxes', 'imtst_cf_rating_vc' );
    function imtst_cf_rating_vc(){
        add_meta_box('client_rating',
                     esc_html__('Ratings', 'indeed-my-testimonials-vc'),
                     'imtst_metabox_rating_vc', //function available in function.php
                     IMTST_POST_TYPE_VC,
                     'normal',
                     'low');
    }
	 #CUSTOM LINK
    add_action( 'add_meta_boxes', 'imtst_custom_href_vc' );
    function imtst_custom_href_vc(){
    	add_meta_box('postcustomhref',
    			esc_html__( 'Select Target Link', 'indeed-my-testimonials-vc'),
    			'imtstCustomHrefMetaBox_vc',
    			IMTST_POST_TYPE_VC,
    			'normal',
    			'high' );
    }
	add_action( 'add_meta_boxes', 'imtst_cf_tsm_vc' );
    function imtst_cf_tsm_vc(){
        add_meta_box('indeed_testi_sm',
                     esc_html__('Client - Social Media connection', 'indeed-my-testimonials-vc'),
                     'imtst_metabox_tsm_vc', //function available in function.php
                     IMTST_POST_TYPE_VC,
                     'normal',
                     'low');
    }
add_filter('content_save_pre', 'imtst_removeHTMLtags_vc');
function imtst_removeHTMLtags_vc($content) {

	return $content;
	//DISABLED for now
    if ( isset($GLOBALS['post_type']) && $GLOBALS['post_type']==IMTST_POST_TYPE_VC ) return strip_tags($content);
    else return $content;
}
//////////CUSTOM ADMIN COLUMNS
///IMAGE COLUMN
add_filter('manage_edit-'.IMTST_POST_TYPE_VC.'_columns', 'imtst_custom_admin_column_vc');
function imtst_custom_admin_column_vc($columns) {
	$new_columns['cb'] = '<input type="checkbox" />';
	$new_columns['title'] = esc_html__('Client Name', 'indeed-my-testimonials-vc');
	$new_columns['quote'] = esc_html__('Quote', 'indeed-my-testimonials-vc');
	$new_columns['postimagecdiv'] = esc_html__('Client Image', 'indeed-my-testimonials-vc');
	$new_columns['taxonomy-'.IMTST_TAXONOMY_VC] = esc_html__('Groups', 'indeed-my-testimonials-vc');
	$new_columns['company'] = 'Company';
	$new_columns['rating'] = 'Rating';
	$new_columns['date'] = _x('Date', 'column name');
	return $new_columns;
}
add_action('manage_posts_custom_column',  'imtst_display_columns_vc' );
function imtst_display_columns_vc($name) {
	global $post;
	if( is_plugin_active('indeed-my-testimonials/indeed-my-testimonials.php') ) return;
	$screen = get_current_screen();
	if($screen->post_type==IMTST_POST_TYPE_VC){
		switch($name){
			case 'postimagecdiv':
				$src = wp_get_attachment_image_src( get_post_thumbnail_id($post->ID), 'thumbnail', false, '' );
			    if ($src && isset($src[0])){
	            	echo "<img src='{$src[0]}' width='50' height='50' title='{$post->post_title}'/>";
	            } else {
	            	$src = get_option('default_client_img');
	            	echo "<img src='".$src."' width='50' height='50' title='{$post->post_title}'/>";
	            }
			break;
			case 'quote':
				$the_content = $post->post_content;
				$arr = explode(" ", $the_content);
				if (count($arr) > 15){
					array_splice($arr, 15);
					$the_content = implode(" ", $arr);
					$the_content .= " ...";
				}
				echo $the_content;
			break;
			case 'company':
				$data = get_post_meta($post->ID, 'imtst_company', true);
				if ($data) echo $data;
			break;
			case 'rating':
				$data = get_post_meta($post->ID, 'imtst_stars', true);
				if ($data) echo imtst_return_stars_vc($data);
			break;
		}
	}
}
////////SHORTCODE
add_shortcode( 'indeed-my-testimonials-vc', 'imtst_shortcode_func_team_vc' );
function imtst_shortcode_func_team_vc($attr){
    $return_str = true;
    include IMTST_DIR_PATH_VC . 'includes/imtst_view.php';
    return $final_str;
}
////////SHORTCODE Form Builder
add_shortcode( 'indeed-my-testimonials-form-vc', 'imtst_form_shortcode_vc' );
function imtst_form_shortcode_vc($attr){
    wp_enqueue_style ( 'imtst_style_vc', IMTST_DIR_URL_VC.'files/css/style.css' );
    wp_enqueue_script ( 'imtst_vc_js', IMTST_DIR_URL_VC.'files/js/functions.js', array(), null );
    $return_str = true;
    $str = '';
    include IMTST_DIR_PATH_VC . 'includes/imtst_form_view.php';
    return $str;
}
////STYLE AND JS
add_action('wp_enqueue_scripts', 'imtst_fe_head_vc');
function imtst_fe_head_vc(){
  wp_enqueue_style( 'imtst_style_vc', IMTST_DIR_URL_VC.'files/css/style.css' );
  wp_enqueue_style( 'imtst_owl_carousel_vc', IMTST_DIR_URL_VC.'files/css/owl.carousel.css' );
  wp_enqueue_style( 'imtst_font-awesome', IMTST_DIR_URL_VC.'files/css/font-awesome.min.css' );
  wp_enqueue_script( 'jquery' );
  wp_enqueue_script( 'imtst_owl_carousel_js', IMTST_DIR_URL_VC.'files/js/owl.carousel.js', array(), null );
  wp_enqueue_script( 'imtst_front_end_testimonials_js', IMTST_DIR_URL_VC .'files/js/front_end.js', array(), null );
  wp_enqueue_script( 'imtst_isotope_pkgd_min_vc', IMTST_DIR_URL_VC.'files/js/isotope.pkgd.min.js', array(), null );
}
add_action("admin_enqueue_scripts", 'imtst_be_head_vc');
function imtst_be_head_vc(){
	wp_enqueue_style ( 'imtstvc_style-dashboard', IMTST_DIR_URL_VC.'files/css/dashboard.css' );
    $screen = get_current_screen();
    if( $screen->post_type==IMTST_POST_TYPE_VC ){
          wp_enqueue_style( 'imtst_font-awesome', IMTST_DIR_URL_VC.'files/css/font-awesome.min.css' );
          wp_enqueue_style( 'imtst_style_vc', IMTST_DIR_URL_VC.'files/css/style.css' );
          wp_enqueue_style( 'imtst_owl_carousel_css', IMTST_DIR_URL_VC.'files/css/owl.carousel.css' );
          wp_enqueue_script( 'jquery' );
          wp_enqueue_script( 'imtst_functions_vc', IMTST_DIR_URL_VC.'files/js/functions.js', array(), null );
          wp_enqueue_script( 'imtst_owl_carousel_js', IMTST_DIR_URL_VC.'files/js/owl.carousel.js', array(), null );
          if( function_exists( 'wp_enqueue_media' ) ){
          	wp_enqueue_media();
          	wp_enqueue_script ( 'imtst_open_media_3_5-vc', IMTST_DIR_URL_VC . 'files/js/open_media_3_5.js', array(), null );
          }else{
          	wp_enqueue_style( 'thickbox' );
          	wp_enqueue_script( 'thickbox' );
          	wp_enqueue_script( 'media-upload' );
          	wp_enqueue_script ( 'imtst_open_media_3_4-vc', IMTST_DIR_URL_VC . 'files/js/open_media_3_4.js', array(), null );
          }
    }
}
//////  INSIDE TEMPLATE OPTION
add_filter( 'template_include', 'imtst_portfolio_page_template_vc', 99 );
function imtst_portfolio_page_template_vc( $template ) {
    if(get_post_type()==IMTST_POST_TYPE_VC && isset($_REQUEST['imtst_cpt']) && $_REQUEST['imtst_cpt']!=''){
    	if($_REQUEST['imtst_cpt']=='IMTST_PAGE_TEMPLATE'){
    		//return our awesome page template
    		return IMTST_DIR_PATH_VC.'includes/imtst_page_template.php';
    	}
        $template = urldecode($_REQUEST['imtst_cpt']);
        $template .= ".php";
    	$new_template = locate_template( $template );
        return $new_template;
    }
    else return $template;
}

#Enable feature image for IMTST_POST_TYPE
add_action( 'init', 'imtst_theme_suport_vc');
function imtst_theme_suport_vc(){
	$postTypes = get_theme_support( 'post-thumbnails' );
	if(isset($postTypes) && is_array($postTypes)){
		$postTypes[] = IMTST_POST_TYPE;
		add_theme_support( 'post-thumbnails', $postTypes );
	}else{
		add_theme_support( 'post-thumbnails' );
	}
}

///////////////GENERAL SETTINGS
add_action( 'admin_menu', 'imtst_menu_testimonials_vc' );
function imtst_menu_testimonials_vc(){
	if(function_exists('imtst_shortcode_menu_testimonials')) return;
	add_submenu_page( 'edit.php?post_type='.IMTST_POST_TYPE_VC, esc_html__('General Settings', 'indeed-my-testimonials-vc'), esc_html__('General Settings', 'indeed-my-testimonials-vc'), 'manage_options', 'testimonials_general_settings_vc', 'imtst_general_settings_vc' );
}

$ext_menu = 'edit.php?post_type=' . IMTST_POST_TYPE_VC;
//include_once plugin_dir_path(__FILE__) . 'extensions_plus/index.php';


function imtst_general_settings_vc(){
	include_once IMTST_DIR_PATH_VC . 'includes/general_settings.php';
}

///Ajax change post type name
function imtst_change_post_type_vc(){
	if(isset($_REQUEST['post_name']) && $_REQUEST['post_name']!=''){
		if(get_option('imtst_post_type_name')!==FALSE) update_option('imtst_post_type_name', $_REQUEST['post_name']);
		else add_option('imtst_post_type_name', $_REQUEST['post_name']);
		echo $_REQUEST['post_name'];
	}
	die();
}
add_action('wp_ajax_imtst_change_post_type_vc', 'imtst_change_post_type_vc');
add_action('wp_ajax_nopriv_imtst_change_post_type_vc', 'imtst_change_post_type_vc');

/////custom css for admin table
if (is_admin()){
	add_action('admin_head', 'imtst_custom_admin_css_vc');
	function imtst_custom_admin_css_vc(){

		$output = '';
	 $output .= 'body.post-type-'.IMTST_POST_TYPE_VC.' #posts-filter .wp-list-table #company{
		 width: 10% !important;
	 }';
	 $output .= 'body.post-type-'.IMTST_POST_TYPE_VC.' #posts-filter .wp-list-table #rating{
		 width: 12% !important;
	 }';

	 wp_register_style( 'dummy-handle', false );
	 wp_enqueue_style( 'dummy-handle' );
	 wp_add_inline_style( 'dummy-handle', $output );
	}
}

add_action( 'wp_dashboard_setup', 'imtstvc_register_admindashboard' );
function imtstvc_register_admindashboard() {
	$args = array(
			'posts_per_page'   => 25,
			'orderby'          => 'date',
			'order'            => 'DESC',
			'post_type'        => IMTST_POST_TYPE_VC,
			'post_status'      => 'pending',
	);
	$testimonials = get_posts($args);
	if ($testimonials && count($testimonials)){
		add_meta_box('indeed', 'Indeed My Testimonials - Pending', 'indeed_print_dashboard_widget_imtstvc', 'dashboard', 'normal', 'high');
	}
}


add_action('init', 'imtstvcSetCookie');
function imtstvcSetCookie() {
	if(isset($_POST['imtst_button'])){
		$serializedData = hash('md5',serialize($_POST));
		setcookie('indeed_stop_submit_form', $serializedData,   60 * 60 + time() );
	}
}
